#! /bin/bash

service_array=(config-manager watch-dog cloud-proxy RemoteTerminalDaemon service-monitor)

if [ $# == 3 ] ; then
        cd ../bin && ./mbusd >>/tmp/linkedge.log 2>&1
        sleep 1
        ./tool_config -g3 $1 $2 $3
        cd - &>/dev/null
fi

if [ $# == 5 ] ; then
        cd ../bin && ./mbusd >>/tmp/linkedge.log 2>&1
        sleep 1
        ./tool_config -g3 $1 $2 $3
        sleep 1
        ./tool_config -s gw_system_as_host $4
        sleep 1
        ./tool_config -s gw_system_as_port $5
        cd - &>/dev/null
fi

#Terminate the service started
stop_services() {
        cd ../script
	./iot_gateway_stop_lite.sh
	cd - &>/dev/null
}

start_services(){

        #create mbus mbusd dir
        mkdir -p /var/tmp/var/run/mbusd/

        #first start the mbus
        cd ../bin && ./mbusd >>/tmp/linkedge.log 2>&1 && cd - &>/dev/null
        sleep 1
        ${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: mbusd"

        cd ../bin && ./logger && cd - &>/dev/null
        ${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: logger"

        for service in ${service_array[@]}
        do
            cd ../bin
            (./${service} &>/dev/null &)
            cd - &>/dev/null
            ${Q}echo -e "[  \033[32m+\033[0m  ]  Start Service: ${service}"
            sleep 1
        done
}

display_pkdnds(){
        cd ../bin && ./tool_config -g3
        cd - &>/dev/null
}

${Q}echo "----------------------------------------------------------"
${Q}echo -e "              \033[0;31mStop Link IoT Edge Lite Running Services\033[0m"
${Q}echo "----------------------------------------------------------"
stop_services
${Q}echo ""

${Q}echo "----------------------------------------------------------"
${Q}echo -e "           \033[32mStart Link IoT Edge Services Success\033[0m   "
${Q}echo "----------------------------------------------------------"
${Q}echo ""
start_services

${Q}echo "----------------------------------------------------------"
${Q}echo -e "              \033[0;33mDisplay Link IoT Edge Info \033[0m"
${Q}echo "----------------------------------------------------------"
display_pkdnds
${Q}echo ""

